package kartelj.aleksandar.hellospark;

import java.util.Arrays;
import java.util.List;

import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;

/**
 *http://spark.apache.org/docs/latest/programming-guide.html
 */
public class AppMapAndReduceWithLambda {
	public static void main(String[] args) {
		SparkConf conf = new SparkConf();
		conf.setAppName("hellospark");
		conf.setMaster("local[*]");

		List<Integer> numbers = Arrays.asList(1, 2, 4, 6, 4, 7, 8, 9);
		JavaSparkContext sc = new JavaSparkContext(conf);
		JavaRDD<Integer> distributedNumbers = sc.parallelize(numbers);
		Integer result = distributedNumbers.map((x) -> x * x).reduce(
				(x, y) -> x + y);
		System.out.println(result);
	}
}
