package kartelj.aleksandar.various;

import java.util.List;

import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaPairRDD;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;

import scala.Tuple2;

/**
 * http://spark.apache.org/docs/latest/programming-guide.html
 *
 */
public class Drugi {
	public static void main(String[] args) {
		SparkConf conf = new SparkConf();
		conf.setAppName("app");
		conf.setMaster("local[*]");

		JavaSparkContext sc = new JavaSparkContext(conf);
		JavaRDD<String> lines = sc.textFile("src/brojevi1.txt");
		// mapiramo u brojeve
		JavaRDD<Integer> numbers = lines.map(x -> Integer.valueOf(x));
		// mapiramo u parove samo da bismo mogli da pozovemo kasnije sortByKey
		// nad JavaPairRDD<T>
		// jer ne postoji sort nad JavaRDD<T>
		JavaPairRDD<Integer, Integer> numberOnePairs = numbers
				.mapToPair(x -> new Tuple2<>(x, 1));
		// sada sortiramo po kljucu sto je zapravo prvi element uredjenog para
		JavaPairRDD<Integer, Integer> sortedNumberOnePairs = numberOnePairs
				.sortByKey(false);
		// uzimamo prvih 100 parova na drajver
		List<Tuple2<Integer, Integer>> top100 = sortedNumberOnePairs.take(100);
		for (Tuple2<Integer, Integer> p : top100)
			System.out.println(p._1());
	}
}
